package ru.dbotthepony.mc.otm.registry

import net.minecraftforge.eventbus.api.IEventBus
import net.minecraftforge.registries.DeferredRegister
import net.minecraftforge.registries.ForgeRegistries
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.data.LootTableAppender
import ru.dbotthepony.mc.otm.data.LootTableBasicAppender
import ru.dbotthepony.mc.otm.data.LootTableSeparatedAppender
import ru.dbotthepony.mc.otm.data.RandomizableItemLootAppender

object LootModifiers {
	private val registry = DeferredRegister.create(ForgeRegistries.Keys.GLOBAL_LOOT_MODIFIER_SERIALIZERS, OverdriveThatMatters.MOD_ID)

	init {
		registry.register("loot_appender") { LootTableAppender.CODEC }
		registry.register("loot_appender_separated") { LootTableSeparatedAppender.CODEC }
		registry.register("loot_appender_basic") { LootTableBasicAppender.CODEC }
		registry.register("randomizable_item_loot_appender") { RandomizableItemLootAppender.Companion }
	}

	internal fun register(bus: IEventBus) {
		registry.register(bus)
	}
}
